c----------------------------------------------------------------
      subroutine clnqgj(a,n1,n2,n,m,isw)
C---------------------------------------------------------------
C      caluculate A^{-1}B for complex martrices A and B
C
C      n1  : max # of row
C      n2  : max # of column
C      n   : effective # of row
C      m   : effective # of column / 2 (???)
C
C      input : a=(A,B)
C      output: a=(E,A^{-1}B)
C              isw : errorlevel, =0 : solved, =1 : not solved
c----------------------------------------------------------------
      dimension a(n1,n2)
      complex a,w
c
      epsl=1.e-30
      nplsm=n+m
C
C   Do Loop 100
      do 100 nn=1,n
        knn=nn
        p=0.0
        nnpls1=knn+1
C
C     Do Loop 20
        do 20 i=knn,n
          if(p.lt.cabs(a(i,knn))) then
            p=cabs(a(i,knn))
            ip=i
          end if
   20   continue
C
        if(p.le.epsl) then
          isw=1
          write(6,1000) isw
 1000     format(/,1x,'** isw =',i5,' in clnqgj **')
          goto 999
C----------------------------------------------------------------------
        else
C
          do 50 j=knn,nplsm
            w=a(knn,j)
            a(knn,j)=a(ip,j)
            a(ip,j)=w
   50     continue
C
          do 60 j=nnpls1,nplsm
            a(knn,j)=a(knn,j)/a(knn,knn)
   60     continue
C
          do 90 i=1,n
            if(i.ne.knn) then
              do 80 j=nnpls1,nplsm
   80           a(i,j)=a(i,j)-a(i,knn)*a(knn,j)
            end if
   90     continue
        endif
  100 continue
C
          isw=0
C
  999 return
      end
